<template>
  <button v-if="show_navigate_back" type="button" class="btn btn-link" @click="go_back">
    ← {{ $t('extension.go_back') }}
  </button>
  <div v-if="state==='LOADING'">
    {{ $t('general.loading') }}
  </div>
  <div v-if="state==='RESULT'">
    <h2>
      <a :href=journal.ref_journal class="hidden-link">{{ journal.title }}</a>
      <journal-eligibility-badge class="ms-2 mb-1" :journal="journal"></journal-eligibility-badge>
    </h2>
    <p v-if="journal.alternative_title !== null" class="text-muted">{{ journal.alternative_title }}</p>

    <div class="container">
      <div class="row">
        <div class="col-sm-7">
          <table class="table table-borderless">
            <tbody>
                <tr>
                  <td class="right-aligned">
                    {{ $t('general.publisher') }}:
                  </td>
                  <td>
                    {{ entry_or_not_provided(journal.publisher_name) }}
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    ISSNs:
                  </td>
                  <td>
                    {{ issns }}
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    {{ $t('journaldetails.publication_time') }}:
                  </td>
                  <td>
                    {{ entry_or_not_provided(journal.publication_time_weeks, '{} ' + $t('general.pub_time_unit')) }}
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    {{ $t('general.languages') }}:
                  </td>
                  <td>
                    {{ entry_or_not_provided(array_to_string(languages)) }}
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    {{ $t('general.retain_copyright') }}:
                  </td>
                  <td>
                    {{ entry_or_not_provided(journal.copyright_author_retains) }}
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    {{ $t('general.receives_doi') }}:
                  </td>
                  <td>
                    {{ entry_or_not_provided(journal.doi_pid_scheme) }}
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    {{ $t('general.peer_review') }}:
                  </td>
                  <td>
                    {{ entry_or_not_provided(array_to_string(journal.editorial_review_process)) }}
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    {{ $t('general.license') }}:
                  </td>
                  <td>
                    {{ entry_or_not_provided(array_to_string(licenses)) }}
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    {{ $t('general.apcs') }}:
                  </td>
                  <td>
                    <span v-if="journal.has_apc">{{ journal.apc_max.price }} {{ journal.apc_max.currency }}<span v-if="journal.apc_max.euro"> (approx. {{ journal.apc_max.euro }}€)</span></span>
                    <span v-else>None</span>
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    {{ $t('general.plans') }}:
                  </td>
                  <td>
                    {{ entry_or_not_provided(journal.plan_s_compliance) }}
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    {{ $t('journaldetails.in_doaj') }}:
                  </td>
                  <td>
                    {{ formatted_date }}
                  </td>
                </tr>
                <tr>
                  <td class="right-aligned">
                    {{ $t('general.doaj_seal') }}:
                  </td>
                  <td>
                    {{ bool_to_unicode(journal.doaj_seal) }}
                  </td>
                </tr>
            </tbody>
          </table>
        </div>
        <div class="col-sm-5">
          <a v-if="journal.ref_journal" :href="journal.ref_journal" target="_blank" rel="noopener noreferrer" class="m-2 link-button btn btn-outline-primary">{{ $t('journaldetails.website') }}</a>
          <a v-if="journal.ref_author_instructions" :href="journal.ref_author_instructions" target="_blank" rel="noopener noreferrer" class="m-2 link-button btn btn-outline-primary">{{ $t('journaldetails.author_instr') }}</a>
          <a v-if="journal.aims_scope" :href="journal.aims_scope" target="_blank" rel="noopener noreferrer" class="m-2 link-button btn btn-outline-primary">{{ $t('journaldetails.aims') }}</a>
          <a v-if="journal.editorial_board_url" :href="journal.editorial_board_url" target="_blank" rel="noopener noreferrer" class="m-2 link-button btn btn-outline-primary">{{ $t('journaldetails.editorial') }}</a>
          <div class="mt-4">
            <h5>{{ $t('general.subjects') }}:</h5>
            <div v-if="journal.subjects" class="d-flex flex-wrap">
              <p class="subject bubble py-1 px-2 mx-2 my-1" v-for="subject in journal.subjects" :key="subject.term">{{ subject.term }}</p>
            </div>
            <p v-else><em>{{ $t('general.not_provided') }}</em></p>
          </div>
          <div>
            <h5>{{ $t('general.keywords') }}:</h5>
            <div v-if="journal.keywords" class="d-flex flex-wrap">
              <p class="keyword bubble py-1 px-2 mx-2 my-1" v-for="keyword in journal.keywords" :key="keyword">{{ keyword }}</p>
            </div>
            <p v-else><em>{{ $t('general.not_provided') }}</em></p>
          </div>
        </div>
      </div>
    </div>
    <div v-if="is_extension" class="mt-3 alert alert-secondary d-flex flex-row" role="alert">
      <div class="me-auto">
        <a :href="$t('extension.support_url')" target="_blank" rel="noopener noreferrer">{{ $t('extension.support_linktext') }}</a><br />
        {{ $t('extension.contact_linktext') }} <a :href="'mailto:' + contact_mail">{{ contact_mail }}</a>
      </div>
      <img
        v-if="institution_logo !== null"
        loading="lazy"
        :src="institution_logo"
        alt="Logo of instiution providing the extension"
        id="extension-img" />
    </div>
  </div>
  <div v-if="state==='ERROR'">
    {{ $t('journaldetails.error') }}
  </div>
</template>

<script>
import helper from '../helper'
import RouterMetaMixin from '@/router/RouterMetaMixin.js'
import JournalEligibilityBadge from '../components/JournalEligibilityBadge.vue'
import { mapState } from 'vuex'

export default {
  name: 'Journal',
  title: 'journaldetails.title',
  mixins: [helper, RouterMetaMixin],
  components: { JournalEligibilityBadge },
  data () {
    return {
      journal: {},
      state: 'LOADING'
    }
  },
  created () {
    for (const journal of this.$store.state.journals) {
      if (journal.id === this.$route.params.id) {
        this.journal = journal
        this.state = 'RESULT'
        break
      }
    }
    if (Object.keys(this.journal).length === 0) {
      fetch(this.get_api_url() + 'api/public/v1/journal/' + this.$route.params.id)
        .then(function (response) {
          if (!response.ok) {
            throw Error(response.statusText)
          }
          return response
        }).then(response => response.json())
        .then(data => {
          this.journal = data
          this.state = 'RESULT'
        }).catch(_ => {
          this.state = 'ERROR'
        })
    }
  },
  methods: {
    entry_or_not_provided (val, fmtStr) {
      if (val === null || val === undefined) {
        return 'not provided'
      } else if (typeof val === 'boolean') {
        return this.bool_to_unicode(val)
      } else if (fmtStr !== undefined) {
        return fmtStr.replace('{}', val)
      }
      return val
    },
    array_to_string (array) {
      if (!Array.isArray(array)) {
        return null
      }
      if (array.length > 2) {
        return array.slice(0, -2).join(', ') + ', ' + array.slice(-2).join(' and ')
      } else {
        return array.slice(-2).join(' and ')
      }
    },
    go_back () {
      this.$router.go(-1)
    }
  },
  computed: {
    formatted_date () {
      return this.localize_date(this.journal.created_date)
    },
    languages () {
      return this.journal.languages.map(l => this.lang_code_detailed(l))
    },
    issns () {
      return [this.journal.pissn, this.journal.eissn].filter(i => typeof i === 'string').join(', ')
    },
    licenses () {
      return this.journal.licenses.map(l => l.typex)
    },
    ...mapState({
      institution_logo: state => state.extension.institution_logo,
      contact_mail: state => state.extension.contact_mail,
      is_extension: state => state.extension.is_set
    }),
    show_navigate_back () {
      return this.in_iframe()
    }
  }
}
</script>

<style scoped>
td {
  width: 50%;
}
.right-aligned {
  text-align: right;
}
.link-button {
  display: block;
}
.url-icon {
  height: 0.9em;
  margin-left: 5px;
  vertical-align: baseline;
}
.keyword {
  background-color: #f1f6f1;
}
.subject {
  background-color: #f1f6f6;
}
.bubble {
  border-radius: 20px;
}
.hidden-link {
  color: black;
}
#extension-img {
  max-height: 70px;
  max-width: 140px;
  height: 100%;
}
</style>
